import QtQuick 2.13
import QtQuick.Window 2.13

import QtQuick.Controls 2.12
import QtQuick.Layouts 1.12

Window {
    id: root

    visible: true
    width: 640
    height: 480
    title: qsTr("Hello World")

    function doSomethingExpensive(target, active) {
        // expected is that both Rectangle's tap handler can be in use at the same time
        // both handlers should be taking exclusive grabs, so they function as expected
        // when layered over other handlers
        console.log("changed: " + target + " -> " + active)
    }

    RowLayout {
        anchors.fill: parent

        Item {
            Layout.fillHeight: true
            Layout.fillWidth: true

            Rectangle {
                anchors.fill: parent
                color: "#e8e8e8"
            }

            Rectangle {
                anchors.horizontalCenter: parent.horizontalCenter
                width: Math.min(parent.width, parent.height) * 0.25
                height: width

                color: tap1.active ? "#a6a6a6" : "#d7d7d7"

                TapHandler {
                    id: tap1
                    gesturePolicy: TapHandler.ReleaseWithinBounds
                    onActiveChanged: root.doSomethingExpensive(target, active)
                    onPointChanged: {
                        if (active) {
                            target.y = Math.min(Math.max(0, point.scenePosition.y - point.pressPosition.y), target.parent.height - target.height)
                        }
                    }
                }
            }
        }

        Item {
            Layout.fillHeight: true
            Layout.fillWidth: true


            Rectangle {
                anchors.horizontalCenter: parent.horizontalCenter
                width: Math.min(parent.width, parent.height) * 0.25
                height: width

                color: tap2.active ? "#a6a6a6" : "#d7d7d7"

                TapHandler {
                    id: tap2
                    gesturePolicy: TapHandler.ReleaseWithinBounds
                    onActiveChanged: root.doSomethingExpensive(target, active)
                    onPointChanged: {
                        if (active) {
                            target.y = Math.min(Math.max(0, point.scenePosition.y - point.pressPosition.y), target.parent.height - target.height)
                        }
                    }
                }
            }
        }
    }
}
